%{                                             /* -*- C++ -*- */
//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//

//
// WARNING: Generated file, do not edit by hand!
//


#include <string>
#include <sstream>
#include <cerrno>

#include "common.hh"
#include "misc/escape.hh"

#include "vm/cpu.hh"

#include "parse/asm-scan.hh"

#define YY_NEVER_INTERACTIVE 1

#define YY_USER_ACTION                          \
    yylloc->columns (yyleng);

using inst::Register;
using vm::Cpu;

typedef yy::parser::token token;

%}

%option noyywrap
%option nounput
%option debug

%x STATE_STRING
eol                     \n|\r|\n\r|\r\n

dec_int                 [0-9]+
hex_int                 0x[0-9A-Fa-f]+

id                      [a-zA-Z_][a-zA-Z_0-9]*
%%

%{
  yylloc->step ();
%}

[ \t]+                 yylloc->step ();
[#;][^\n\r]*          yylloc->step ();
{eol}                   yylloc->lines (1); yylloc->step ();

"("                   return token::LPAREN;
")"                   return token::RPAREN;
","                   return token::COMMA;

"+"                   return token::EXP_ADD;
"-"                   return token::EXP_SUB;
"*"                   return token::EXP_MUL;
"/"                   return token::EXP_DIV;

".text"                       return token::DIR_TEXT;
".data"                       return token::DIR_DATA;

".space"              return token::DIR_SPACE;
".byte"                       return token::DIR_BYTE;
".half"                       return token::DIR_HALF;
".word"                       return token::DIR_WORD;
".ascii"              return token::DIR_ASCII;
".asciiz"             return token::DIR_ASCIIZ;

"add"			return token::ADD;
"addu"			return token::ADDU;
"addi"			return token::ADDI;
"addiu"			return token::ADDIU;
"sub"			return token::SUB;
"subu"			return token::SUBU;
"neg"			return token::NEG;
"negu"			return token::NEGU;
"abs"			return token::ABS;
"mul"			return token::MUL;
"div"			return token::DIV;
"divu"			return token::DIVU;
"rem"			return token::REM;
"remu"			return token::REMU;
"sll"			return token::SLL;
"sllv"			return token::SLLV;
"sra"			return token::SRA;
"srav"			return token::SRAV;
"srl"			return token::SRL;
"srlv"			return token::SRLV;
"rol"			return token::ROL;
"ror"			return token::ROR;
"and"			return token::AND;
"andi"			return token::ANDI;
"or"			return token::OR;
"ori"			return token::ORI;
"xor"			return token::XOR;
"xori"			return token::XORI;
"nor"			return token::NOR;
"not"			return token::NOT;
"seq"			return token::SEQ;
"sne"			return token::SNE;
"sge"			return token::SGE;
"sgeu"			return token::SGEU;
"sgt"			return token::SGT;
"sgtu"			return token::SGTU;
"sle"			return token::SLE;
"sleu"			return token::SLEU;
"slt"			return token::SLT;
"sltu"			return token::SLTU;
"slti"			return token::SLTI;
"sltiu"			return token::SLTIU;
"beq"			return token::BEQ;
"beqz"			return token::BEQZ;
"bne"			return token::BNE;
"bnez"			return token::BNEZ;
"bge"			return token::BGE;
"bgeu"			return token::BGEU;
"bgez"			return token::BGEZ;
"bgezal"			return token::BGEZAL;
"bgt"			return token::BGT;
"bgtu"			return token::BGTU;
"bgtz"			return token::BGTZ;
"ble"			return token::BLE;
"bleu"			return token::BLEU;
"blez"			return token::BLEZ;
"blt"			return token::BLT;
"bltu"			return token::BLTU;
"bltz"			return token::BLTZ;
"bltzal"			return token::BLTZAL;
"j"			return token::J;
"jal"			return token::JAL;
"jr"			return token::JR;
"jalr"			return token::JALR;
"lb"			return token::LB;
"lbu"			return token::LBU;
"lw"			return token::LW;
"lui"			return token::LUI;
"li"			return token::LI;
"la"			return token::LA;
"sb"			return token::SB;
"sw"			return token::SW;
"move"			return token::MOVE;
"mfhi"			return token::MFHI;
"mflo"			return token::MFLO;
"mthi"			return token::MTHI;
"mtlo"			return token::MTLO;
"mfc0"			return token::MFC0;
"mtc0"			return token::MTC0;
"syscall"			return token::SYSCALL;
"nop"			return token::NOP;

"$"([0-9]|[12][0-9]|3[01])    {
  yylval->reg = new Register(Register::generic, atoi(yytext +1));
  return token::REGISTER;
}

"$zero"                       {
  yylval->reg = new Register(Register::general, Cpu::zero);
  return token::REGISTER;
}
"$v0"                      {
  yylval->reg = new Register(Register::general, Cpu::v0);
  return token::REGISTER;
}
"$v1"                      {
  yylval->reg = new Register(Register::general, Cpu::v1);
  return token::REGISTER;
}
"$a0"                      {
  yylval->reg = new Register(Register::general, Cpu::a0);
  return token::REGISTER;
}
"$a1"                      {
  yylval->reg = new Register(Register::general, Cpu::a1);
  return token::REGISTER;
}
"$a2"                      {
  yylval->reg = new Register(Register::general, Cpu::a2);
  return token::REGISTER;
}
"$a3"                      {
  yylval->reg = new Register(Register::general, Cpu::a3);
  return token::REGISTER;
}
"$t0"                      {
  yylval->reg = new Register(Register::general, Cpu::t0);
  return token::REGISTER;
}
"$t1"                      {
  yylval->reg = new Register(Register::general, Cpu::t1);
  return token::REGISTER;
}
"$t2"                      {
  yylval->reg = new Register(Register::general, Cpu::t2);
  return token::REGISTER;
}
"$t3"                      {
  yylval->reg = new Register(Register::general, Cpu::t3);
  return token::REGISTER;
}
"$t4"                      {
  yylval->reg = new Register(Register::general, Cpu::t4);
  return token::REGISTER;
}
"$t5"                      {
  yylval->reg = new Register(Register::general, Cpu::t5);
  return token::REGISTER;
}
"$t6"                      {
  yylval->reg = new Register(Register::general, Cpu::t6);
  return token::REGISTER;
}
"$t7"                      {
  yylval->reg = new Register(Register::general, Cpu::t7);
  return token::REGISTER;
}
"$t8"                      {
  yylval->reg = new Register(Register::general, Cpu::t8);
  return token::REGISTER;
}
"$t9"                      {
  yylval->reg = new Register(Register::general, Cpu::t9);
  return token::REGISTER;
}
"$s0"                      {
  yylval->reg = new Register(Register::general, Cpu::s0);
  return token::REGISTER;
}
"$s1"                      {
  yylval->reg = new Register(Register::general, Cpu::s1);
  return token::REGISTER;
}
"$s2"                      {
  yylval->reg = new Register(Register::general, Cpu::s2);
  return token::REGISTER;
}
"$s3"                      {
  yylval->reg = new Register(Register::general, Cpu::s3);
  return token::REGISTER;
}
"$s4"                      {
  yylval->reg = new Register(Register::general, Cpu::s4);
  return token::REGISTER;
}
"$s5"                      {
  yylval->reg = new Register(Register::general, Cpu::s5);
  return token::REGISTER;
}
"$s6"                      {
  yylval->reg = new Register(Register::general, Cpu::s6);
  return token::REGISTER;
}
"$s7"                      {
  yylval->reg = new Register(Register::general, Cpu::s7);
  return token::REGISTER;
}

"$sp"                 {
  yylval->reg = new Register(Register::general, Cpu::sp);
  return token::REGISTER;
}
"$fp"                 {
  yylval->reg = new Register(Register::general, Cpu::fp);
  return token::REGISTER;
}
"$ra"                 {
  yylval->reg = new Register(Register::general, Cpu::ra);
  return token::REGISTER;
}

"$x"{dec_int}         {
  yylval->reg = new Register(Register::unlimited, atoi(yytext +2));
  return token::REGISTER;
}


{id}                    {
  yylval->id = new misc::unique_string(yytext);
  return token::LABEL;
}
{id}":"               {
  yytext[yyleng - 1] = 0; // Remove last character (side-effects on yytext are allowed)
  yylval->id = new misc::unique_string(yytext);
  return token::LABEL_DEF;
}


-?{dec_int}             {
  std::istringstream iss(yytext);

  if (iss.peek() == '-')
    iss >> std::dec >> yylval->i;
  else
    iss >> std::dec >> (unsigned&) yylval->i;

  if (iss.fail())
    {
      std::cerr << *yylloc
                << ": unrecognized integer (may be too large): "
                << yytext << std::endl;
      exit_set (exit_scan);
    }
  return token::INTEGER;
}
-?{hex_int}             {
  std::istringstream iss(yytext);

  if (iss.peek() == '-')
    iss >> std::hex >> yylval->i;
  else
    iss >> std::hex >> (unsigned&) yylval->i;

  if (iss.fail())
    {
      std::cerr << *yylloc
                << ": unrecognized integer (may be too large): "
                << yytext << std::endl;
      exit_set (exit_scan);
    }
  return token::INTEGER;
}

'\\a'                 yylval->i = '\a'; return token::INTEGER;
'\\b'                 yylval->i = '\b'; return token::INTEGER;
'\\f'                 yylval->i = '\f'; return token::INTEGER;
'\\n'                 yylval->i = '\n'; return token::INTEGER;
'\\r'                 yylval->i = '\r'; return token::INTEGER;
'\\t'                 yylval->i = '\t'; return token::INTEGER;
'\\v'                 yylval->i = '\v'; return token::INTEGER;
'\\[\\\']'         yylval->i = yytext[1]; return token::INTEGER;
'\\.'                 {
  std::cerr << *yylloc
            << ": unrecognized escape: " << escape (yytext) << std::endl;
  exit_set (exit_scan);
}
'[^\'\n\r\\]'      yylval->i = yytext[1]; return token::INTEGER;


\"                    yylval->s = new std::string; BEGIN STATE_STRING;
<STATE_STRING>{
  \"                  {
    BEGIN INITIAL;
    return token::STRING;
  }

  \\[0-7]{3}          {
    long c = strtol (yytext + 1, 0, 8);
    if (c > 255)
      {
        std::cerr << *yylloc
                  << ": invalid escape: " << escape (yytext) << std::endl;
        exit_set (exit_scan);
      }
    else
      *(yylval->s) += c;
  }

  \\x[0-9a-fA-F]{2}   {
    *(yylval->s) += strtol (yytext + 2, 0, 16);
  }

  \\a                 *(yylval->s) += '\a';
  \\b                 *(yylval->s) += '\b';
  \\f                 *(yylval->s) += '\f';
  \\n                 *(yylval->s) += '\n';
  \\r                 *(yylval->s) += '\r';
  \\t                 *(yylval->s) += '\t';
  \\v                 *(yylval->s) += '\v';
  \\[\\""]                *(yylval->s) += yytext[1];
  \\.                 {
    std::cerr << *yylloc
              << ": unrecognized escape: " << escape (yytext) << std::endl;
    exit_set (exit_scan);
  }

  [^\"\n\r\\]+            yylval->s->append (yytext, yyleng);

  {eol}                 {
    yylloc->lines (1);
    yylval->s->append ("\n", 1);
  }

  <<EOF>>               {
    std::cerr
      << *yylloc << ": unexpected end of file in a string" << std::endl;
    exit_set (exit_scan);

    BEGIN INITIAL;
    return token::STRING;
  }
}

.                       {
  std::cerr << *yylloc
            << ": invalid character: `"
            << escape (yytext) << "'" << std::endl;
  yylloc->step ();
  exit_set (exit_scan);
}

%%

/* Depending upon the version of Flex (> 2.5.4), there might be a
   function to reclaim all the memory Flex has allocated.  If not,
   simulate it. */
#if !((YY_FLEX_MAJOR_VERSION >= 2                    && YY_FLEX_MINOR_VERSION >= 6) ||            (YY_FLEX_MAJOR_VERSION >= 2                    && YY_FLEX_MINOR_VERSION >= 5                 && defined YY_FLEX_SUBMINOR_VERSION           && YY_FLEX_SUBMINOR_VERSION >= 5))
static void
yylex_destroy(void)
{
  yy_delete_buffer(YY_CURRENT_BUFFER);
}
#endif

#include <stack>

namespace parse
{

  // Stack of scanning states, used to have some (weak) reentrancy.
  static std::stack<YY_BUFFER_STATE> states;

  // Keep this scan_open valid for multiple calls (i.e., do use
  // yyrestart).
  void
  scan_open(const std::string &filename, bool trace_p)
  {
    static bool first = true;
    if (first)
      {
        first = false;

        // Reclaim all the memory allocated by Flex at program termination
        std::atexit((void (*) (void)) yylex_destroy);
      }

    // Save the current state
    states.push(YY_CURRENT_BUFFER);

    yy_flex_debug = trace_p;

    if (filename == "-")
      yyin = stdin;
    else
      {
        yyin = fopen (filename.c_str (), "r");
        if (!yyin)
          {
            std::cerr
              << program_name
              << ": cannot open `" << filename << "': "
              << strerror (errno) << std::endl;
            exit (1);
          }
      }

    yy_switch_to_buffer(yy_create_buffer (yyin, YY_BUF_SIZE));
  }

  void
  scan_close (void)
  {
    fclose (yyin);

    // Restore the current scanning state.
    assertion(!states.empty());
    yy_delete_buffer(YY_CURRENT_BUFFER);
    yy_switch_to_buffer(states.top());
    states.pop();
  }
}

